#ifndef _ERROR_H
#define _ERROR_H

#include <iostream>
#include <glibmm/ustring.h>
#include <glibmm/error.h>
#include <glibmm/quark.h>

//! Base class for errors that might be thrown.

class Error : public Glib::Error{
    protected:
        //! A bool telling whether the error is fatal
        /*!
         * \see Fatal()
         */
        bool m_fatal;
    public:
        static Glib::Quark domain;
        //! Constructor
        /*!
         * \param err the error message string.
         * \param fatal a bool specifying if the program must abor.
         */
        Error(const Glib::ustring& err, bool fatal=false, int code=0)
            :Glib::Error((GQuark)Glib::QueryQuark(domain),code,err),m_fatal(fatal) {}
        //! Get whether the error is fatal or not.
        /*!
         * \return true if the program should abort
         */
        bool Fatal() const {return m_fatal;}
};

#endif
