#include "SgfNode.h"
#include "Logger.h"
#include <glibmm/i18n.h>
#include <gtkmm.h>

//! A derived class of Gtk::Dialog to set up the game properties
class GamePropertiesDialog : public Gtk::Dialog
{
public:
    //!Constructor
    /*!
     * The class is intended to be created by Gtk::Builder. This constructor
     * prototype is mandatory to do so.
     * \param cobject the base class C instance (in that case a GtkDialog struct)
     * \param refBuilder the Gtk::Builder instance.
     */
    GamePropertiesDialog(BaseObjectType* cobject, const Glib::RefPtr<Gtk::Builder>& refBuilder);
    //!Attach a root node to the dialog
    /*!
     * the attached root node will be modified by the dialog according to the user inputs.
     */
    void AttachSgfNode(SgfNode* node);
    void SetComputerGame(bool comp=true);
    void on_black_changed();
    void on_white_changed();
private:
    //!Callback when the 'ok' button is clicked
    void on_ok();
    //!Callback when the 'close' button is clicked
    void on_close() {response(Gtk::RESPONSE_CLOSE);}
    //!The attached root node
    SgfNode* m_node;
    //!A reference to the Gtk::Builder
    Glib::RefPtr<Gtk::Builder> m_refBuilder;
    //!Whether this is a computer game
    bool m_computer;
    Gtk::ComboBoxEntryText m_combo_rule;
    Gtk::ComboBoxEntryText m_combo_black;
    Gtk::ComboBoxEntryText m_combo_white;
};
