#include "GobanWindow.h"
#include <glibmm/i18n.h>
#include <glibmm.h>
#include "Logger.h"

Glib::Quark Error::domain("ggoban error types");

//!main
/*!
 * \todo add arguments parsing, such as a file name to open.
 */
int main(int argc, char** argv)
{
    bindtextdomain(GETTEXT_PACKAGE, PROGRAMNAME_LOCALEDIR);
    bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
    textdomain(GETTEXT_PACKAGE);
    Gtk::Main kit(argc,argv);
    Glib::RefPtr<Gtk::Builder> refXml;
    try{
        refXml=Gtk::Builder::create_from_file(DATADIR"goban.glade");
    } catch(Glib::FileError err){
        cout<<err.what()<<endl;
        return 1;
    } catch(Glib::MarkupError err){
        cout<<err.what()<<endl;
        return 1;
    } catch(Gtk::BuilderError err){
		cout<<err.what()<<endl;
		return 1;
	}
    GobanWindow* win=0;
    refXml->get_widget_derived("GobanWindow",win);
    Gtk::Main::run(*win);
    delete win;
	Logger::log()<<"exited successfully"<<endl;
    return 0;
}
